import router from "@/router";

export function setUUID() {
  if (!localStorage.getItem("uuidForEcs")) {
    const uuidForEcs = "" + Date.now() + Math.random();
    localStorage.setItem("uuidForEcs", uuidForEcs);
  }
}

// 如果这台机器上登录过的学生人数小于5，那么这台电脑就是学生的
export function isThisMachineOwnByStudent() {
  return JSON.parse(localStorage.getItem("userIds") || "[]").length < 5;
}

/** 通用的退出登录函数
 * @param cause - 退出登录的原因
 */
export function showLogout(cause: string) {
  logger({
    pgu: "AUTO",
    cnl: ["console", "local", "server"],
    dtl: "用户被要求重新登录",
    ext: {
      cause,
    },
  });
  $message.warning(cause, { duration: 5 * 60 * 1000, closable: true });
  void router.push({ name: "UserLogin" });
}

/**
 * 将阿拉伯数字转换成汉字数字
 * @param num 数值
 * @returns 汉字数字
 */
export function toChineseNumber(num: number) {
  let ret;
  if (num < 10) {
    ret = num.toLocaleString("zh-u-nu-hanidec");
  } else if (num === 10) {
    ret = "十";
  } else if (num > 10 && num < 20) {
    ret = "十" + (num % 10).toLocaleString("zh-u-nu-hanidec");
  } else if (num >= 20 && num < 100) {
    const s = num
      .toLocaleString("zh-u-nu-hanidec", { useGrouping: false })
      .split("");
    s.splice(1, 0, "十");
    ret = s.join("").replace("〇", "");
  } else {
    ret = num.toLocaleString("zh-u-nu-hanidec"); // 假设没有超过100的大题
  }

  return ret;
}
